#!/usr/bin/perl -w


if($#ARGV != 1)
{
    print "USAGE: TameParallelTCP.pl  ServerName  impact \n";
    print "where impact is between 0 and 1 \n";
    exit(-1);
}

$server = shift; #get the server address/name
$impact = shift; #get the impact limit

if(defined($ENV{IPERFPATH}))
{
    $iperfpath = $ENV{IPERFPATH};
    $iperf = $iperfpath." -c ".$server." -P ";
}else{
    print "Shell variable IPERFPATH Undefined, please read README.txt first.\n";
    exit(-1);
}


$p1 = 1; #probe one parallelism level
$p2 = 10; #probe two parallelism level

print "***********************************\n";
print "Sending the first probe ...\n";
$cmd = $iperf."$p1";
@out1 = `$cmd`;
print "Sending the second probe ...\n";
$cmd = $iperf."$p2";
@out2 = `$cmd`;

$tp1 = 0;
$len = @out1;
for($i=0; $i<$len; $i++)
{
    if($out1[$i] =~ /.+sec\s+(.+)MBytes\s+(.+)\s+Mbits/)
    {
	#print "$2\n";
	$tp1 += $2;
    }
}

$tp2 = 0;
$len = @out2;
for($i=0; $i<$len; $i++)
{
    if($out2[$i] =~ /.+sec\s+(.+)MBytes\s+(.+)\s+Mbits/)
    {
	#print "$2\n";
	$tp2 += $2;
    }
}

print "Probe: \t $p1 \t $tp1 \n";
print "Probe: \t $p2 \t $tp2 \n";
print "***********************************\n";

$ap = (($p2*$p2)/($tp2*$tp2) - ($p1*$p1)/($tp1*$tp1)) / ($p2*$p2-$p1*$p1);
$bp = ($p1*$p1)/($tp1*$tp1) - $ap*$p1*$p1;


$maxN = 0;
$maxTP = 0;
$maxImp = 0;
for($i=1; $i<=30; $i++)
{
    $BW = $i/sqrt($ap*$i*$i+$bp);
    #$relc = ($tp1-$BW/$n)/$tp1;
    $relc = 1 - sqrt(($ap*$p1*$p1 + $bp)/($ap*$i*$i + $bp));
    
    if($relc <= $impact)
    {
	print "$i \t $BW\n";
	print "Impact: $relc\n";
	$maxN++;
	$maxTP = $BW;
	$maxImp = $relc;
    }
}
print "*************************************************************************************\n";
print "Max Number of parallel TCP: $maxN ;    Throughput: $maxTP ;    Impact: $maxImp\n";
print "*************************************************************************************\n";
